---

 source/interpret.c |  189 ++++++++++++++++++++++++++---------------------------
 1 file changed, 96 insertions(+), 93 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -1377,10 +1377,12 @@ static void addToGlobalSymTab(Symbol *sy
     GlobalSymTab[idx] = sym;
 }
 
+#define EXEC_ERROR(s1, s2) return execError(s1, s2)
+
 #define GET_SYM(s) \
     do { \
         if (PC->type != SYM_INST) { \
-            return execError("Unexpected instruction, expected <symbol>: <%s>", \
+            EXEC_ERROR("Unexpected instruction, expected <symbol>: <%s>", \
                     instTypeToStr(PC->type)); \
         } \
         s = PC->val.sym; \
@@ -1390,7 +1392,7 @@ static void addToGlobalSymTab(Symbol *sy
 #define GET_IMMED(i) \
     do { \
         if (PC->type != IMMED_INST) { \
-            return execError("Unexpected instruction, expected <immediate>: <%s>", \
+            EXEC_ERROR("Unexpected instruction, expected <immediate>: <%s>", \
                     instTypeToStr(PC->type)); \
         } \
         i = PC->val.immed; \
@@ -1400,7 +1402,7 @@ static void addToGlobalSymTab(Symbol *sy
 #define GET_BRANCH(a) \
     do { \
         if (PC->type != BRANCH_INST) { \
-            return execError("Unexpected instruction, expected <branch>: <%s>", \
+            EXEC_ERROR("Unexpected instruction, expected <branch>: <%s>", \
                     instTypeToStr(PC->type)); \
         } \
         a = PC + PC->val.branch; \
@@ -1430,7 +1432,7 @@ static void addToGlobalSymTab(Symbol *sy
 #define POP_CHECK(n) \
     do { \
         if (!OK_TO_POP(n)) { \
-            return execError(StackUnderflowMsg, ""); \
+            EXEC_ERROR(StackUnderflowMsg, ""); \
         } \
     } while (0)
 
@@ -1441,17 +1443,17 @@ static void addToGlobalSymTab(Symbol *sy
  #define PUSH_CHECK(n) \
     do { \
         if (!OK_TO_PUSH(n)) { \
-            return execError(StackOverflowMsg, ""); \
+            EXEC_ERROR(StackOverflowMsg, ""); \
         } \
     } while (0)
 
 #define PEEK_CHECK(n) \
     do { \
         if (!OK_TO_POP((n) + 1)) { \
-            return execError(StackUnderflowMsg, ""); \
+            EXEC_ERROR(StackUnderflowMsg, ""); \
         } \
         if (!OK_TO_PUSH(-(n))) { \
-            return execError(StackOverflowMsg, ""); \
+            EXEC_ERROR(StackOverflowMsg, ""); \
         } \
     } while (0)
 
@@ -1480,10 +1482,10 @@ static void addToGlobalSymTab(Symbol *sy
             __int = dataVal.val.n; \
         } else if (dataVal.tag == STRING_TAG) { \
             if (!StringToNum(dataVal.val.str.rep, &__int)) {\
-                return execError(StringToNumberMsg, dataVal.val.str.rep); \
+                EXEC_ERROR(StringToNumberMsg, dataVal.val.str.rep); \
             } \
         } else { \
-            return execError("incompatible type in integer context: <%s>", \
+            EXEC_ERROR("incompatible type in integer context: <%s>", \
                     tagToStr(dataVal.tag)); \
         } \
         number = __int; \
@@ -1497,7 +1499,7 @@ static void addToGlobalSymTab(Symbol *sy
         } else if (dataVal.tag == INT_TAG) { \
             __str = AllocStringOfNumber(dataVal.val.n); \
         } else { \
-            return execError("incompatible type in string context: <%s>", \
+            EXEC_ERROR("incompatible type in string context: <%s>", \
                     tagToStr(dataVal.tag)); \
         } \
         string = __str; \
@@ -1595,7 +1597,7 @@ static int pushSymVal(void)
     	nArgs = FP_GET_ARG_COUNT(FrameP);
     	argNum = s->value.val.n;
     	if (argNum >= nArgs) {
-    	    return execError("referenced undefined argument: %s",  s->name);
+            EXEC_ERROR("referenced undefined argument: %s", s->name);
         }
     	if (argNum == N_ARGS_ARG_SYM) {
             symVal.tag = INT_TAG;
@@ -1608,12 +1610,12 @@ static int pushSymVal(void)
 	char *errMsg;
 	if (!(s->value.val.subr)(FocusWindow, NULL, 0,
 	    	&symVal, &errMsg)) {
-	    return execError(errMsg, s->name);
+            EXEC_ERROR(errMsg, s->name);
         }
     } else
-    	return execError("reading non-variable: %s", s->name);
+        EXEC_ERROR("reading non-variable: %s", s->name);
     if (symVal.tag == NO_TAG && !inTypeOfMode) {
-    	return execError("variable not set: %s", s->name);
+        EXEC_ERROR("variable not set: %s", s->name);
     }
 
     PUSH(symVal);
@@ -1653,8 +1655,8 @@ static int pushArgVal(void)
     --argNum;
     nArgs = FP_GET_ARG_COUNT(FrameP);
     if (argNum >= nArgs || argNum < 0) {
-        return execError("referenced undefined argument: $args[%s]",
-                         longAsStr(argNum + 1));
+        EXEC_ERROR("referenced undefined argument: $args[%s]",
+                longAsStr(argNum + 1));
     }
     PUSH(FP_GET_ARG_N(FrameP, argNum));
     return STAT_OK;
@@ -1693,7 +1695,7 @@ static int pushArgArray(void)
             argVal = FP_GET_ARG_N(FrameP, argNum);
             if (!ArrayInsert(argArray, AllocStringOfNumber(argNum + 1),
                              &argVal)) {
-                return(execError("argument array insertion failure", NULL));
+                EXEC_ERROR("argument array insertion failure", NULL);
             }
         }
     }
@@ -1729,7 +1731,7 @@ static int pushArraySymVal(void)
     	dataPtr = &sym->value;
     }
     else {
-    	return execError("assigning to non-lvalue array or non-array: %s", sym->name);
+        EXEC_ERROR("assigning to non-lvalue array or non-array: %s", sym->name);
     }
 
     if (initEmpty && dataPtr->tag == NO_TAG) {
@@ -1738,7 +1740,7 @@ static int pushArraySymVal(void)
     }
 
     if (dataPtr->tag == NO_TAG && !inTypeOfMode) {
-        return execError("variable not set: %s", sym->name);
+        EXEC_ERROR("variable not set: %s", sym->name);
     }
 
     PUSH(*dataPtr);
@@ -1831,7 +1833,7 @@ static int anonArrayNextVal(void)
 
     sprintf(numString, "%d", nextIndex);
     if (!ArrayInsert(&anonArray, AllocStringCpy(numString), &exprVal)) {
-        return(execError("array insertion failure", NULL));
+        EXEC_ERROR("array insertion failure", NULL);
     }
 
     /* we need to increment the index for next time */
@@ -1883,7 +1885,7 @@ static int anonArrayIndexVal(void)
     }
 
     if (!ArrayInsert(&anonArray, keyString, &exprVal)) {
-        return(execError("array insertion failure", NULL));
+        EXEC_ERROR("array insertion failure", NULL);
     }
 
     /* push the default next index value first, then the array */
@@ -1974,7 +1976,7 @@ static int namedArg1orN(Boolean isFirst)
     /* if our index is numeric (or can be converted to a number) we must
        change the next index value */
     if (nDim == 1 && StringToNum(keyString, &index)) {
-        return execError("named argument name must not be numeric", NULL);
+        EXEC_ERROR("named argument name must not be numeric", NULL);
     }
 
     if (isFirst) {
@@ -1988,7 +1990,7 @@ static int namedArg1orN(Boolean isFirst)
     }
 
     if (!ArrayInsert(&argsArray, keyString, &exprVal)) {
-        return(execError("named argument insertion failure", NULL));
+        EXEC_ERROR("named argument insertion failure", NULL);
     }
 
     /* and (re)push the array */
@@ -2036,13 +2038,13 @@ static int assign(void)
 
     if (sym->type != GLOBAL_SYM && sym->type != LOCAL_SYM) {
         if (sym->type == ARG_SYM) {
-            return execError("assignment to function argument: %s",  sym->name);
+            EXEC_ERROR("assignment to function argument: %s", sym->name);
         }
         else if (sym->type == PROC_VALUE_SYM) {
-            return execError("assignment to read-only variable: %s", sym->name);
+            EXEC_ERROR("assignment to read-only variable: %s", sym->name);
         }
         else {
-            return execError("assignment to non-variable: %s", sym->name);
+            EXEC_ERROR("assignment to non-variable: %s", sym->name);
         }
     }
 
@@ -2158,13 +2160,13 @@ static int add(void)
                     rightIter = arrayIterateNext(rightIter);
                 }
                 if (!insertResult) {
-                    return(execError("array insertion failure", NULL));
+                    EXEC_ERROR("array insertion failure", NULL);
                 }
             }
             PUSH(resultArray);
         }
         else {
-            return(execError("can't mix math with arrays and non-arrays", NULL));
+            EXEC_ERROR("can't mix math with arrays and non-arrays", NULL);
         }
     }
     else {
@@ -2172,7 +2174,7 @@ static int add(void)
         POP_INT(n1);
         PUSH_INT(n1 + n2);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -2224,13 +2226,13 @@ static int subtract(void)
                     leftIter = arrayIterateNext(leftIter);
                 }
                 if (!insertResult) {
-                    return(execError("array insertion failure", NULL));
+                    EXEC_ERROR("array insertion failure", NULL);
                 }
             }
             PUSH(resultArray);
         }
         else {
-            return(execError("can't mix math with arrays and non-arrays", NULL));
+            EXEC_ERROR("can't mix math with arrays and non-arrays", NULL);
         }
     }
     else {
@@ -2238,7 +2240,7 @@ static int subtract(void)
         POP_INT(n1);
         PUSH_INT(n1 - n2);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -2265,7 +2267,7 @@ static int divide(void)
     POP_INT(n2);
     POP_INT(n1);
     if (n2 == 0) {
-	return execError("division by zero", "");
+        EXEC_ERROR("division by zero", "");
     }
     PUSH_INT(n1 / n2);
     return STAT_OK;
@@ -2281,7 +2283,7 @@ static int modulo(void)
     POP_INT(n2);
     POP_INT(n1);
     if (n2 == 0) {
-	return execError("modulo by zero", "");
+        EXEC_ERROR("modulo by zero", "");
     }
     PUSH_INT(n1 % n2);
     return STAT_OK;
@@ -2362,11 +2364,11 @@ static int eq(void)
         }
     }
     else {
-        return(execError("incompatible types to compare", NULL));
+        EXEC_ERROR("incompatible types to compare", NULL);
     }
     v1.tag = INT_TAG;
     PUSH(v1);
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /* negated eq() call */
@@ -2419,13 +2421,13 @@ static int bitAnd(void)
                     rightIter = arrayIterateNext(rightIter);
                 }
                 if (!insertResult) {
-                    return(execError("array insertion failure", NULL));
+                    EXEC_ERROR("array insertion failure", NULL);
                 }
             }
             PUSH(resultArray);
         }
         else {
-            return(execError("can't mix math with arrays and non-arrays", NULL));
+            EXEC_ERROR("can't mix math with arrays and non-arrays", NULL);
         }
     }
     else {
@@ -2433,7 +2435,7 @@ static int bitAnd(void)
         POP_INT(n1);
         PUSH_INT(n1 & n2);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -2490,13 +2492,13 @@ static int bitOr(void)
                     rightIter = arrayIterateNext(rightIter);
                 }
                 if (!insertResult) {
-                    return(execError("array insertion failure", NULL));
+                    EXEC_ERROR("array insertion failure", NULL);
                 }
             }
             PUSH(resultArray);
         }
         else {
-            return(execError("can't mix math with arrays and non-arrays", NULL));
+            EXEC_ERROR("can't mix math with arrays and non-arrays", NULL);
         }
     }
     else {
@@ -2504,7 +2506,7 @@ static int bitOr(void)
         POP_INT(n1);
         PUSH_INT(n1 | n2);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 static int and(void)
@@ -2604,7 +2606,7 @@ static int concatenateNwithSep(int nVals
             len += value.val.str.len;
         }
         else {
-            return execError("incompatible type in string context: <%s>",
+            EXEC_ERROR("incompatible type in string context: <%s>",
                     tagToStr(value.tag));
         }
     }
@@ -2726,7 +2728,7 @@ static int callSubroutineFromSymbol(Symb
     	PreemptRequest = False;
 	if (!sym->value.val.subr(FocusWindow, StackP,
 	    	nArgs, &result, &errMsg))
-	    return execError(errMsg, sym->name);
+            EXEC_ERROR(errMsg, sym->name);
         PUSH_RET_VAL(result);
     	return PreemptRequest ? STAT_PREEMPT : STAT_OK;
     }
@@ -2761,8 +2763,7 @@ static int callSubroutineFromSymbol(Symb
 	Window win;
 
         if (haveNamedArgs) {
-            return execError(
-                    "%s action routine called with named argument array",
+            EXEC_ERROR("%s action routine called with named argument array",
                     sym->name);
         }
 
@@ -2798,7 +2799,7 @@ static int callSubroutineFromSymbol(Symb
     }
 
     /* Calling a non subroutine symbol */
-    return execError("%s is not a function or subroutine", sym->name);
+    EXEC_ERROR("%s is not a function or subroutine", sym->name);
 }
 
 /*
@@ -2868,7 +2869,7 @@ static int callSubroutineUnpackArray(voi
     POP(argArray);
 
     if (argArray.tag != ARRAY_TAG) {
-        return execError("argument array call made with non-array value", NULL);
+        EXEC_ERROR("argument array call made with non-array value", NULL);
     }
 
     if (haveNamedArgs) {
@@ -2902,7 +2903,7 @@ static int callSubroutineUnpackArray(voi
         }
         else {
             if (!ArrayInsert(&dvArray, iter->key, &dvEntry)) {
-                return(execError("array copy failed", NULL));
+                EXEC_ERROR("array copy failed", NULL);
             }
         }
 
@@ -2977,7 +2978,7 @@ int OverlayRoutineFromProg(Program *prog
 */
 static int fetchRetVal(void)
 {
-    return execError("internal error: frv", NULL);
+    EXEC_ERROR("internal error: frv", NULL);
 }
 
 /* see comments for returnValOrNone() */
@@ -3120,17 +3121,17 @@ int ArrayCopy(DataValue *dstArray, DataV
                 return(errNum);
             }
             if (!ArrayInsert(dstArray, srcIter->key, &tmpArray)) {
-                return(execError("array copy failed", NULL));
+                return STAT_ERROR;
             }
         }
         else {
             if (!ArrayInsert(dstArray, srcIter->key, &srcIter->value)) {
-                return(execError("array copy failed", NULL));
+                return STAT_ERROR;
             }
         }
         srcIter = arrayIterateNext(srcIter);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -3150,7 +3151,7 @@ static int makeArrayKeyFromArgs(int nArg
     if (len > 0) {
         return len;
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -3467,23 +3468,24 @@ static int arrayRef(void)
         POP(srcArray);
         if (srcArray.tag == ARRAY_TAG) {
             if (!ArrayGet(&srcArray, keyString, &valueItem)) {
-                return(execError("referenced array value not in array: %s", keyString));
+                EXEC_ERROR("referenced array value not in array: %s",
+                        keyString);
             }
             PUSH(valueItem);
-            return(STAT_OK);
+            return STAT_OK;
         }
         else {
-            return(execError("operator [] on non-array", NULL));
+            EXEC_ERROR("operator [] on non-array", NULL);
         }
     }
     else {
         POP(srcArray);
         if (srcArray.tag == ARRAY_TAG) {
             PUSH_INT(ArraySize(&srcArray));
-            return(STAT_OK);
+            return STAT_OK;
         }
         else {
-            return(execError("operator [] on non-array", NULL));
+            EXEC_ERROR("operator [] on non-array", NULL);
         }
     }
 }
@@ -3520,7 +3522,7 @@ static int arrayAssign(void)
         POP(dstArray);
 
         if (dstArray.tag != ARRAY_TAG && dstArray.tag != NO_TAG) {
-            return(execError("cannot assign array element of non-array", NULL));
+            EXEC_ERROR("cannot assign array element of non-array", NULL);
         }
         if (srcValue.tag == ARRAY_TAG) {
             DataValue arrayCopyValue;
@@ -3532,13 +3534,13 @@ static int arrayAssign(void)
             }
         }
         if (ArrayInsert(&dstArray, keyString, &srcValue)) {
-            return(STAT_OK);
+            return STAT_OK;
         }
         else {
-            return(execError("array member allocation failure", NULL));
+            EXEC_ERROR("array member allocation failure", NULL);
         }
     }
-    return(execError("empty operator []", NULL));
+    EXEC_ERROR("empty operator []", NULL);
 }
 
 /*
@@ -3576,20 +3578,21 @@ static int arrayRefAndAssignSetup(void)
         PEEK(srcArray, nDim);
         if (srcArray.tag == ARRAY_TAG) {
             if (!ArrayGet(&srcArray, keyString, &valueItem)) {
-                return(execError("referenced array value not in array: %s", keyString));
+                EXEC_ERROR("referenced array value not in array: %s",
+                        keyString);
             }
             PUSH(valueItem);
             if (binaryOp) {
                 PUSH(moveExpr);
             }
-            return(STAT_OK);
+            return STAT_OK;
         }
         else {
-            return(execError("operator [] on non-array", NULL));
+            EXEC_ERROR("operator [] on non-array", NULL);
         }
     }
     else {
-        return(execError("array[] not an lvalue", NULL));
+        EXEC_ERROR("array[] not an lvalue", NULL);
     }
 }
 
@@ -3622,16 +3625,16 @@ static int beginArrayIter(void)
         iteratorValPtr = &FP_GET_SYM_VAL(FrameP, iterator);
     }
     else {
-        return(execError("bad temporary iterator: %s",  iterator->name));
+        EXEC_ERROR("bad temporary iterator: %s", iterator->name);
     }
 
     iteratorValPtr->tag = INT_TAG;
     if (arrayVal.tag != ARRAY_TAG) {
-        return(execError("can't iterate non-array", NULL));
+        EXEC_ERROR("can't iterate non-array", NULL);
     }
 
     iteratorValPtr->val.arrayPtr = arrayIterateFirst(&arrayVal);
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -3688,7 +3691,7 @@ static int arrayIter(void)
         keyValPtr = &(keySym->value);
     }
     else {
-        return(execError("can't assign to: %s",  keySym->name));
+        EXEC_ERROR("can't assign to: %s", keySym->name);
     }
     keyValPtr->tag = NO_TAG;
 
@@ -3700,7 +3703,7 @@ static int arrayIter(void)
             valPtr = &(valSym->value);
         }
         else {
-            return(execError("can't assign to: %s",  valSym->name));
+            EXEC_ERROR("can't assign to: %s", valSym->name);
         }
         valPtr->tag = NO_TAG;
     }
@@ -3709,7 +3712,7 @@ static int arrayIter(void)
         iteratorValPtr = &FP_GET_SYM_VAL(FrameP, iterator);
     }
     else {
-        return(execError("bad temporary iterator: %s",  iterator->name));
+        EXEC_ERROR("bad temporary iterator: %s", iterator->name);
     }
 
     thisEntry = iteratorValPtr->val.arrayPtr;
@@ -3730,7 +3733,7 @@ static int arrayIter(void)
     else {
         JUMP(branchAddr);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -3758,21 +3761,21 @@ static int beginArrayIterArray(void)
         iteratorValPtr = &FP_GET_SYM_VAL(FrameP, iterator);
     }
     else {
-        return(execError("bad temporary iterator: %s",  iterator->name));
+        EXEC_ERROR("bad temporary iterator: %s", iterator->name);
     }
 
     if (nDims < 0) {
-        return(execError("bad multi dimension", NULL));
+        EXEC_ERROR("bad multi dimension", NULL);
     }
 
     iteratorValPtr->tag = INT_TAG;
     if (arrayVal.tag != ARRAY_TAG) {
-        return(execError("can't iterate non-array", NULL));
+        EXEC_ERROR("can't iterate non-array", NULL);
     }
 
     iteratorValPtr->val.arrayPtr = arrayIterateFirst(&arrayVal);
 
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 static int countDim(const char *key)
@@ -3868,7 +3871,7 @@ static int arrayIterArray(void)
         keyArrayPtr = &(keyArraySym->value);
     }
     else {
-        return(execError("can't assign to: %s",  keyArraySym->name));
+        EXEC_ERROR("can't assign to: %s", keyArraySym->name);
     }
     keyArrayPtr->tag = ARRAY_TAG;
     keyArrayPtr->val.arrayPtr = NULL;
@@ -3881,7 +3884,7 @@ static int arrayIterArray(void)
             valPtr = &valSym->value;
         }
         else {
-            return(execError("can't assign to: %s",  valSym->name));
+            EXEC_ERROR("can't assign to: %s", valSym->name);
         }
         valPtr->tag = NO_TAG;
     }
@@ -3890,7 +3893,7 @@ static int arrayIterArray(void)
         iteratorValPtr = &FP_GET_SYM_VAL(FrameP, iterator);
     }
     else {
-        return(execError("bad temporary iterator: %s",  iterator->name));
+        EXEC_ERROR("bad temporary iterator: %s", iterator->name);
     }
 
     thisEntry = iteratorValPtr->val.arrayPtr;
@@ -3911,7 +3914,7 @@ static int arrayIterArray(void)
 
         /* set keys */
         if (!splitKeyIntoArray(thisEntry->key, keyArrayPtr)) {
-            return(execError("can't split key: %s",  thisEntry->key));
+            EXEC_ERROR("can't split key: %s", thisEntry->key);
         }
 
         if (withVal) {
@@ -3955,7 +3958,7 @@ static int inArray(void)
 
     POP(theArray);
     if (theArray.tag != ARRAY_TAG) {
-        return(execError("operator in on non-array", NULL));
+        EXEC_ERROR("operator in on non-array", NULL);
     }
     PEEK(leftArray, 0);
     if (leftArray.tag == ARRAY_TAG) {
@@ -3976,7 +3979,7 @@ static int inArray(void)
         }
     }
     PUSH_INT(inResult);
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 /*
@@ -4019,15 +4022,15 @@ static int deleteArrayElement(void)
         }
     }
     else {
-        return(execError("attempt to delete from non-array", NULL));
+        EXEC_ERROR("attempt to delete from non-array", NULL);
     }
-    return(STAT_OK);
+    return STAT_OK;
 }
 
 static int typeOfIn(void)
 {
     if (inTypeOfMode) {
-        return(execError("I'm already in typeof-mode", NULL));
+        EXEC_ERROR("I'm already in typeof-mode", NULL);
     }
 
     inTypeOfMode = 1;
@@ -4041,7 +4044,7 @@ static int typeOfOut(void)
     DataValue retVal;
 
     if (!inTypeOfMode) {
-        return(execError("I'm not in typeof-mode", NULL));
+        EXEC_ERROR("I'm not in typeof-mode", NULL);
     }
 
     inTypeOfMode = 0;
@@ -4092,7 +4095,7 @@ static int arrayAssignNext(void)
     POP(dstArray);
 
     if (dstArray.tag != ARRAY_TAG && dstArray.tag != NO_TAG) {
-        return execError("cannot assign array element of non-array", NULL);
+        EXEC_ERROR("cannot assign array element of non-array", NULL);
     }
 
     if (srcValue.tag == ARRAY_TAG) {
@@ -4108,7 +4111,7 @@ static int arrayAssignNext(void)
     keyString = AllocStringOfNumber(arrayMaxNumIdx(&dstArray) + 1);
 
     if (!ArrayInsert(&dstArray, keyString, &srcValue)) {
-        return execError("array member allocation failure", NULL);
+        EXEC_ERROR("array member allocation failure", NULL);
     }
 
     return STAT_OK;
@@ -4132,7 +4135,7 @@ static int arrayNextNumIdx(void)
 
     POP(srcArray);
     if (srcArray.tag != ARRAY_TAG) {
-        return execError("operator [@] on non-array", NULL);
+        EXEC_ERROR("operator [@] on non-array", NULL);
     }
 
     PUSH_INT(arrayMaxNumIdx(&srcArray) + 1);
@@ -4147,9 +4150,9 @@ static int arrayNextNumIdx(void)
 static int errCheck(const char *s)
 {
     if (errno == EDOM)
-	return execError("%s argument out of domain", s);
+        EXEC_ERROR("%s argument out of domain", s);
     else if (errno == ERANGE)
-	return execError("%s result out of range", s);
+        EXEC_ERROR("%s result out of range", s);
     else
         return STAT_OK;
 }
